SystemOrganization addCategory: #'Pier-Exporter-Code'!

!String methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:05'!
codeOn: aStream
	aStream nextPut: $'.
	self do: [ :aChar |
		aChar = $' ifTrue: [ aStream nextPut: $' ].
		aStream nextPut: aChar ].
	aStream nextPut:  $'! !

!Date methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:51'!
codeOn: aStream
	aStream << '(' << self class greaseString << ' year: '; print: self year; << ' month: '; print: self monthIndex; << ' day: '; print: self dayOfMonth; << ')'! !

!MAAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/9/2012 15:48'!
asCodeFor: structure description: description value: value exporter: exporter on: stream
	exporter exportHelper asCodeFor: structure description: description value: value on: stream! !

!Duration methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/7/2012 17:16'!
codeOn: aStream
	aStream << '(' << self class greaseString <<  ' days: '; print: self days; << ' hours: '; print: self hours; << ' minutes: '; print: self minutes; << ' seconds: '; print: self seconds; << ')' ! !

!MASelectorAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/9/2012 15:54'!
asCodeFor: structure description: description value: value exporter: exporter on: stream
	stream << '	structure ' << self writeSelector greaseString << ' ' << value << '.'! !

!UndefinedObject methodsFor: '*pier-exporter-code' stamp: 'NickAger 1/26/2012 16:18'!
codeOn: aStream
	aStream << 'nil'! !

!DateAndTime methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:55'!
codeOn: aStream
	aStream << '(' << self class greaseString << ' year: '; print: self year; << ' month: '; print: self monthIndex; << ' day: '; print: self dayOfMonth; << ' hour: '; print: self hour; << ' minute: '; print: self minute; << ' second: '; print: self second; << ')' ! !

MAVisitor subclass: #PRCodeBuilderDescriptionVisitor
	instanceVariableNames: 'structure stream methods exporter selectorsWithCommonDefaults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

PRCodeBuilderDescriptionVisitor class
	instanceVariableNames: 'aComponent'!

PRCodeBuilderDescriptionVisitor class
	instanceVariableNames: 'aComponent'!

!PRCodeBuilderDescriptionVisitor class methodsFor: 'instance creation' stamp: 'NickAger 1/26/2012 17:13'!
structure: structure methods: methods exporter: exporter on: stream
	^ self basicNew
		initializeWithStructure: structure methods: methods exporter: exporter stream: stream
		yourself! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'private' stamp: 'NickAger 2/9/2012 15:41'!
addCodeFor: aDescription value: value
	aDescription accessor asCodeFor: structure description: aDescription value: value exporter: exporter on: stream.
	stream nextPut: Character cr! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'modifying' stamp: 'NickAger 12/12/2011 12:29'!
addMethod: method
	self methods add: method! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'initialization' stamp: 'NickAger 1/26/2012 17:14'!
initializeWithStructure: aStructure methods: methodsCollection exporter: anExporter stream: aStream
	self initialize.
	
	structure := aStructure.
	methods := methodsCollection.
	exporter := anExporter.
	stream := aStream! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'check defaults' stamp: 'NickAger 1/26/2012 15:56'!
isCommonDefault: aDescription
	| accessor descriptionDefault structureValue defaultCheckBlock |
	
	"Unfortunately the description frequently doesn't define a default value, but there are a common set of defaults we don't need to write.
	We key off the readSelector and check against a dictionary for common defaults"
	accessor := aDescription accessor.
	(accessor class canUnderstand: #readSelector) ifFalse: [ ^ false ].
	defaultCheckBlock := self selectorsWithCommonDefaults at: accessor readSelector ifAbsent: [ ^ false ].
	
	^ defaultCheckBlock value! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'check defaults' stamp: 'NickAger 1/26/2012 15:46'!
isDefaultDescriptionValue: aDescription
	| descriptionDefault structureValue |
	
	descriptionDefault := aDescription default.
	structureValue := aDescription accessor read: structure.
	^ descriptionDefault = structureValue ! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'check defaults' stamp: 'NickAger 1/26/2012 16:36'!
isNil: aDescription
	^ (aDescription accessor read: structure) = nil
! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'accessing' stamp: 'NickAger 12/12/2011 16:19'!
methods
	^ methods! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'check defaults' stamp: 'NickAger 1/26/2012 15:55'!
selectorsWithCommonDefaults
	^ selectorsWithCommonDefaults ifNil: [ 
		selectorsWithCommonDefaults := Dictionary new
			at: #name put: [ true ];
			at: #title put: [ structure title = structure name capitalized ];
			at: #menu put: [ structure menu = structure title ];
			at: #tags put: [ structure tags isEmpty ];
			at: #hideFromMenus put: [ structure hideFromMenus not ];
			yourself ]! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'visiting' stamp: 'NickAger 1/26/2012 16:34'!
visit: aDescription
	"only visit writable descriptions - otherwise we can't initialise it."
	(aDescription accessor canWrite: structure) ifFalse: [ ^ self ]. 
	
	"only visit descriptions with non-default values"
	(self isDefaultDescriptionValue: aDescription) ifTrue: [ ^ self ].
	(self isNil: aDescription) ifTrue: [ ^ self ].
	(self isCommonDefault: aDescription) ifTrue: [ ^ self ].

	aDescription acceptMagritte: self! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'visiting' stamp: 'NickAger 12/12/2011 15:16'!
visitDescription: aDescription
	| value |
	value := (aDescription accessor read: structure) asCode.
	self addCodeFor: aDescription value: value! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'visiting' stamp: 'NickAger 2/9/2012 15:46'!
visitDocumentDescription: aDescription
	"could have used:
		 value := (aDescription toString: (aDescription accessor read: structure)) asCode
	but I thought it was good to be explicit that we require wiki format output"
	| value |
	value := (PRWikiWriter write: (aDescription accessor read: structure)) asCode.
	self addCodeFor: aDescription value: value! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'visiting' stamp: 'NickAger 1/26/2012 16:11'!
visitFileDescription: aDescription
	| fileModel |
	fileModel := aDescription accessor read: structure.
	stream 
		<< '	structure file: (' << fileModel class greaseString << ' new
		filename: ' << fileModel filename asCode << ';
		mimetype: ' << fileModel mimetype asCode << ';
		contents: ' << (fileModel isText ifTrue: [ fileModel contents asString asCode ] ifFalse: [ fileModel contents greaseString ]) << ').' << String cr

! !

!PRCodeBuilderDescriptionVisitor methodsFor: 'visiting' stamp: 'NickAger 2/9/2012 15:42'!
visitStructureDescription: aDescription
	| structureSelector subStructure |
	subStructure := aDescription accessor read: structure.
	aDescription accessor asCodeFor: structure description: aDescription value: ' (self ', subStructure asSelector, ': kernel)' exporter: exporter on: stream.
	stream nextPut: Character cr.
	
	self methods addAll: (exporter writeCodeFor: subStructure)! !

!Array methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:47'!
codeOn: aStream
	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!PRDocumentAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/11/2012 21:39'!
asCodeFor: structure description: description value: value exporter: exporter on: stream
	(description label = 'Contents' or: [ description label = 'Description' ]) ifTrue: [ 
		^ stream << '	structure contents: ' << value << '.' ].
		
	super asCodeFor: structure description: description value: value exporter: exporter on: stream! !

!Symbol methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 18:20'!
codeOn: aStream
	aStream << '#' << self! !

!WideString methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 19:09'!
codeOn: aStream
	aStream << '(WideString fromByteArray: '; print: self asByteArray; << ')'! !

!Object methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 16:58'!
asCode
	^ String streamContents: [ :stream | self codeOn: stream ]! !

!Object methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:09'!
codeOn: aStream
	self printOn: aStream! !

GRObject subclass: #PRCodeExportHelperBase
	instanceVariableNames: 'recursiveMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRCodeExportHelperBase class methodsFor: 'instance creation' stamp: 'NickAger 2/9/2012 15:07'!
recursiveMethods: recursiveMethodsCollection
	^ self new
		recursiveMethods: recursiveMethodsCollection;
		yourself! !

!PRCodeExportHelperBase methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 16:02'!
asCodeFor: structure description: description value: value on: stream
	stream << '	(structure magritteDescription detect: [ :each | each label = ''' << description label << ''' ]) accessor write: ' << value << ' to: structure. '! !

!PRCodeExportHelperBase methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 15:15'!
handlerPRComponent: aPRComponent initialisationOn: stream
	self subclassResponsibility! !

!PRCodeExportHelperBase methodsFor: 'accessing' stamp: 'NickAger 2/9/2012 15:06'!
recursiveMethods
	^ recursiveMethods! !

!PRCodeExportHelperBase methodsFor: 'accessing' stamp: 'NickAger 2/9/2012 15:06'!
recursiveMethods: anObject
	recursiveMethods := anObject! !

PRCodeExportHelperBase subclass: #PRPier1or2ToPier1or2ExportHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRPier1or2ToPier1or2ExportHelper methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 15:51'!
asCodeFor: structure description: description value: value on: stream
	| structureClass |
	structureClass := structure class greaseString.
	stream << '(' << structureClass << ' description detect: [ :each | each label = ''' << description label << ''' ]) accessor write: ' << value << ' to: structure. '! !

!PRPier1or2ToPier1or2ExportHelper methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 15:10'!
handlerPRComponent: aPRComponent initialisationOn: stream
	aPRComponent settings associationsDo: [ :aDescriptionValuePair |
		stream << '	structure write: ' << aDescriptionValuePair value asCode << 
			' using: ' << aPRComponent componentClass name << ' ' 
				<< (self selectorFromDescription: aDescriptionValuePair key onClass: aPRComponent componentClass)
				<< '.' << String cr.
		
		"if the value is a structure we need to make sure we avoid a recursive loop "
		(aDescriptionValuePair value isKindOf: PRStructure) ifTrue: [ 
			recursiveMethods add: aDescriptionValuePair value asSelector ] ]! !

!PRPier1or2ToPier1or2ExportHelper methodsFor: 'export helpers' stamp: 'NickAger 2/20/2012 15:08'!
selectorFromDescription: aDescription onClass: aClass
	| descriptionSelectors |
	descriptionSelectors := SortedCollection withAll: (aClass class allSelectors select: [ :each | each isDescriptionDefinition ]).		
	
	^ descriptionSelectors detect: [ :each |  (aClass perform: each) = aDescription ]! !

PRCodeExportHelperBase subclass: #PRPier1or2ToPier3ExportHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRPier1or2ToPier3ExportHelper methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 15:09'!
handlerPRComponent: aPRComponent initialisationOn: stream
	stream << '	structure prototypeInstance: (' << aPRComponent componentClass name << ' new' << String cr.
	aPRComponent settings associationsDo: [ :aDescriptionValuePair |
		| accessor |
		accessor := aDescriptionValuePair key accessor.
		(accessor class canUnderstand: #readSelector) ifTrue: [
			stream << '		' << accessor readSelector << ': ' << aDescriptionValuePair value asCode << ';' << String cr ].
		
		"if the value is a structure we need to make sure we avoid a recursive loop "
		(aDescriptionValuePair value isKindOf: PRStructure) ifTrue: [ 
			self recursiveMethods add: aDescriptionValuePair value asSelector ] ].
	stream << '		yourself).' << String cr.! !

PRCodeExportHelperBase subclass: #PRPier3ToPier3ExportHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRPier3ToPier3ExportHelper methodsFor: 'export helpers' stamp: 'NickAger 2/9/2012 15:09'!
handlerPRComponent: aPRComponent initialisationOn: stream
	| defaultValueComponent prototypeInstance |
	
	stream << '	structure prototypeInstance: (' << aPRComponent componentClass name << ' new' << String cr.
	
	defaultValueComponent := aPRComponent componentClass new.
	prototypeInstance := aPRComponent prototypeInstance.
	
	prototypeInstance magritteDescription do: [ :aDescription |
		| value |
		
		value := prototypeInstance readUsing: aDescription.
		"only write values which are different from the defaults"
		(value ~= (defaultValueComponent readUsing: aDescription)) ifTrue: [
			| accessor |
			accessor := aDescription accessor.
			(accessor class canUnderstand: #readSelector) ifTrue: [
				stream << '		' << accessor readSelector << ': ' << value asCode << ';' << String cr ].
		
			"if the value is a structure we need to make sure we avoid a recursive loop "
			(value isKindOf: PRStructure) ifTrue: [ 
				self recursiveMethods add: value asSelector ] ] ].
	
	stream << '		yourself).' << String cr.	! !

GRObject subclass: #PRKernelCodeExporter
	instanceVariableNames: 'selectorsWithCommonDefaults exportedMethods recursiveMethods add standardPermissions standardOtherPermissions isPier3 dispatcherPathName exportHelper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRKernelCodeExporter class methodsFor: 'instance creation' stamp: 'NickAger 2/7/2012 17:04'!
exportAsPier1Or2Kernel: kernelOrPierDispatchPath
	^ self new
		setOldPRComponentGeneration;
		exportWithPierKernelOrDispatchPath: kernelOrPierDispatchPath;
		yourself! !

!PRKernelCodeExporter class methodsFor: 'instance creation' stamp: 'NickAger 2/7/2012 17:04'!
exportAsPier3Kernel: kernelOrPierDispatchPath
	^ self new
		setPrototypePRComponentGeneration;
		exportWithPierKernelOrDispatchPath: kernelOrPierDispatchPath;
		yourself! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 16:08'!
addDispatcherPathNameOn: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'dispatcherPathName' << String cr <<
			'	^ ' << dispatcherPathName asCode ].
	self compile: method into: component classified: #constants
! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/28/2012 18:51'!
addKernelGroups: kernel to: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'addGroupsToKernel: kernel' << String cr <<
			'	kernel propertyAt: #groups put:' << String cr <<
			' 		(Set new' << String cr. 
		kernel groups do: [ :group |
			stream << '			add: '.
			self writeGroup: group on: stream ]. 
	stream << '			yourself).' << String cr.
	stream << '	kernel propertyAt: #adminGroup put: (kernel groupNamed: ''' << kernel adminGroup name << ''' ifNone: nil)' << String cr ].
	self compileMethod: method intoComponent: component! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 16:08'!
addKernelNameAccessorMethod: aKernel forComponent: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'kernelName' << String cr <<
			'	^ ' << aKernel name asCode ].
	self compile: method into: component classified: #constants! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/28/2012 18:52'!
addKernelUsers: kernel to: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'addUsersToKernel: kernel' << String cr <<
			'	kernel propertyAt: #users put: (Set new' << String cr. 
		kernel users do: [ :user |
			stream << '		add: '.
			self writeUser: user on: stream ]. 
	stream << '		yourself).' << String cr.
	stream << 
		'	kernel propertyAt: #adminUser put: (kernel userNamed: ''' << kernel adminUser name << ''' ifNone: nil)' << String cr ].
	self compileMethod: method intoComponent: component
	
! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 13:22'!
addRootAccessorMethodOn: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'root' << String cr <<
			'	^ root'].
	self compileMethod: method intoComponent: component! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 2/20/2012 21:20'!
checkStreamPipeOperatorExists
	"some old images dont have WriteStream>>#<< so we add it here - was faster than changing all the code "
	(WriteStream includesSelector: #<<) ifFalse: [
		self compile: '	| newEnd |
	collection class == aCollection class ifFalse:
		[ aCollection putOn: self. ^ self ].

	newEnd := position + aCollection size.
	newEnd > writeLimit ifTrue:
		[self growTo: newEnd + 10].

	collection replaceFrom: position+1 to: newEnd  with: aCollection startingAt: 1.
	position := newEnd.' into: WriteStream classified: '*pier-exporter-code' ]! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/26/2012 14:48'!
compile: aString into: aClass classified: classificationSymbol
	GRPlatform current 
		compile: aString
		into: aClass
		classified: classificationSymbol
! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/26/2012 14:49'!
compileMethod: method intoComponent: component
	self compile: method into: component classified: #'exported code'



! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:12'!
compileMethods: methods intoComponent: component
	methods do: [ :method |
		self compileMethod: method intoComponent: component ]


! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 12:33'!
createClassFor: kernel 
	^ self createClassFor: kernel instanceVariableNames: 'root'! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 07:56'!
createClassFor: kernel instanceVariableNames: instanceVariableNames
	^ PRKernelCreatorBase
		subclass: (self selectorFromName: kernel name, 'KernelCreator') capitalized  
		instanceVariableNames: instanceVariableNames
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Pier-Exported-Code'! !

!PRKernelCodeExporter methodsFor: 'accessing' stamp: 'NickAger 2/8/2012 17:29'!
dispatcherPathName
	dispatcherPathName ifNil: [ dispatcherPathName := self kernelName ]! !

!PRKernelCodeExporter methodsFor: 'accessing' stamp: 'NickAger 2/9/2012 15:37'!
exportHelper
	^ exportHelper! !

!PRKernelCodeExporter methodsFor: 'accessing' stamp: 'NickAger 2/9/2012 15:37'!
exportHelper: anObject
	exportHelper := anObject! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/20/2012 21:19'!
exportKernel: kernel
	| component rootComponent |
	
	self checkStreamPipeOperatorExists.
	
	component := self createClassFor: kernel.
	self addKernelNameAccessorMethod: kernel forComponent: component.
	self addDispatcherPathNameOn: component.
	self addRootAccessorMethodOn: component.

	self addKernelGroups: kernel to: component.
	self addKernelUsers: kernel to: component.
	
	rootComponent := kernel root.
	
	self compile: (self rootTemplate: rootComponent)
		into: component
		classified: #'exported code'.
		
	rootComponent enumerator with all do: [ :structure |
		| methods |
		methods := self writeCodeFor: structure.
		self compileMethods: methods intoComponent: component ].
	
	self rewriteRecursiveMethodsFor: kernel! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/20/2012 14:57'!
exportWithPierKernelOrDispatchPath: kernelOrPierDispatchPath
	| kernel |
	
	kernel := kernelOrPierDispatchPath isString 
		ifTrue: [ 
			dispatcherPathName := kernelOrPierDispatchPath.
			self kernelFromDispatcherConfiguration: dispatcherPathName ]
		ifFalse: [ 
			dispatcherPathName := self selectorFromName: kernelOrPierDispatchPath name.
			kernelOrPierDispatchPath ].
	
	self exportKernel: kernel! !

!PRKernelCodeExporter methodsFor: 'initialization' stamp: 'NickAger 2/7/2012 17:03'!
initialize
 	super initialize.
	
	exportedMethods := Set new.
	recursiveMethods := Set new! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 2/20/2012 14:46'!
isPier1
	^ (Smalltalk at: #WAEntryPoint ifAbsent: [ ]) notNil! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 2/20/2012 14:47'!
isPier3
	^ isPier3 ifNil: [
		isPier3 := (Smalltalk at: #MAPragmaBuilder ifAbsent: [ ]) notNil ]! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 2/20/2012 14:54'!
kernelFromDispatcherConfiguration: dispatcherPath
	^ self isPier1 
		ifTrue: [ (WADispatcher default entryPointAt: dispatcherPath) configuration valueAt: #kernel ]
		ifFalse: [ (WADispatcher default handlerAt: dispatcherPath) configuration valueAt: #kernel ]! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 2/7/2012 15:10'!
magritteSelector
	^ self isPier3  
		ifTrue: [ #magritteDescription ]
		ifFalse: [ #description ]! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 12:33'!
rewriteRecursiveMethodsFor: kernel
	| instanceVariables component |
	instanceVariables := String streamContents: [ :stream |
		stream << 'root '.
		recursiveMethods do: [ :each | 
			stream nextPutAll: each ]
			separatedBy: [ stream nextPut: Character space ] ].
		
	component := self createClassFor: kernel instanceVariableNames: instanceVariables.
	
	"this is somewhat hacky - we rewrite reentrant component creation methods with lazy initialiser using a regex match
	a two pass generator would remove the need for this hack - but would be more complex. "
	recursiveMethods do: [ :each | 
		| regex initialAssignment propertySetting method |
		regex := '.*(structure \:=[[:print:]]+)(.*)\^ structure' asRegex.
		regex search: (component sourceCodeAt: (each, ':') asSymbol).
		self assert: (regex subexpressionCount = 3).
		initialAssignment :=  regex subexpression: 2.
		propertySetting :=  regex subexpression: 3.
		method := String streamContents: [ :stream |
			stream 
				<<  each << ': kernel' << String cr
				<< '	 ^ ' << each << ' ifNil: [ ' << String cr
				<< '		| structure |' << String cr
				<< '		' << initialAssignment << String cr
				<< '		' << each << ' := structure.'
				<< propertySetting << String cr		
				<< '		' << each << ' ]' ].
				
		self compileMethod: method intoComponent: component ]! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 12:33'!
rootTemplate: rootComponent
	^ String streamContents: [ :stream | 
		stream << 'root: kernel
	^ root ifNil: [
		root := self ' << (rootComponent asSelector) << ': kernel ]']! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 12/12/2011 20:13'!
selectorFromName: aName
	| selector |
	selector := aName select: [ :each | each isAlphaNumeric ].
	[ selector first isDigit ]
		whileTrue: [ selector := selector allButFirst ].
		
	selector at: 1 put: (selector at: 1) asLowercase.
		
	^ selector asSymbol! !

!PRKernelCodeExporter methodsFor: 'initialization' stamp: 'NickAger 2/9/2012 15:39'!
setOldPRComponentGeneration
	self exportHelper: (PRPier1or2ToPier1or2ExportHelper recursiveMethods: recursiveMethods)! !

!PRKernelCodeExporter methodsFor: 'initialization' stamp: 'NickAger 2/9/2012 15:38'!
setPrototypePRComponentGeneration
	self exportHelper: (self isPier3 
		ifTrue: [ PRPier3ToPier3ExportHelper recursiveMethods: recursiveMethods ]
		ifFalse: [ PRPier1or2ToPier3ExportHelper recursiveMethods: recursiveMethods ])! !

!PRKernelCodeExporter methodsFor: 'accessing' stamp: 'NickAger 1/29/2012 11:30'!
standardOtherPermissions
	^ standardOtherPermissions ifNil: [
		standardOtherPermissions := PUSecurity new otherPermissions ]! !

!PRKernelCodeExporter methodsFor: 'accessing' stamp: 'NickAger 1/29/2012 11:30'!
standardPermissions
	^ standardPermissions ifNil: [
		standardPermissions :=  PUSecurity new ownerPermissions ]! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/9/2012 17:07'!
writeCodeFor: structure
	| methods method codeBuilder selector |
	selector := structure asSelector.
	
	"recursion guard"
	(exportedMethods includes: selector)
		ifTrue: [ recursiveMethods add: selector. ^ #() ]
		ifFalse: [ exportedMethods add: selector ].
	
	methods := OrderedCollection new.
	
	method :=  String streamContents: [ :stream | 
		stream << selector << ': kernel' << String cr << 
			'	| structure  |' << String cr <<
			'	structure := ' << structure class greaseString << ' named: ''' << structure name << '''.' << String cr.

		codeBuilder := PRCodeBuilderDescriptionVisitor structure: structure methods: methods exporter: self on: stream.
		(structure perform: self magritteSelector) do: [ :aDescription |
			codeBuilder visit: aDescription ].
		
		structure class name = #PRComponent ifTrue: [ self exportHelper handlerPRComponent: structure initialisationOn: stream ].

		structure enumerator do: [ :each | 
			stream << '	structure addChild: (self ' << (each asSelector) << ': kernel).' << String cr ].
	
		self writeOwnershipAndSecurityCodeFor: structure on: stream.
		
		stream <<'	^ structure' ].
	
	methods add: method.
	^ methods! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/28/2012 18:49'!
writeGroup: group on: stream
	stream << '(PUGroup named: ''' << group name << ''');' << String cr! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 2/8/2012 17:17'!
writeOwnershipAndSecurityCodeFor: structure on: stream
	| securityDecoration |
	securityDecoration := structure securityDecoration.
	
	securityDecoration owner notNil ifTrue: [	
		stream nextPut: Character cr.	
		stream << '	structure securityDecoration owner: (kernel userNamed: ''' << structure securityDecoration owner name << ''' ifNone: nil).' << String cr.
		structure securityDecoration ownerPermissions = self standardPermissions ifFalse: [
			stream << '	structure securityDecoration ownerPermissions: '.
			self writePermissions: structure securityDecoration ownerPermissions on: stream ] ].
	
	securityDecoration group notNil ifTrue: [	
		stream << '	structure securityDecoration group: (kernel groupNamed: ''' << structure securityDecoration group name << ''' ifNone: nil).' << String cr.
		structure securityDecoration groupPermissions = self standardPermissions ifFalse: [
			stream << '	structure securityDecoration groupPermissions: '.
			self writePermissions: structure securityDecoration groupPermissions on: stream ] ].

	structure securityDecoration otherPermissions = self standardOtherPermissions ifFalse: [		
		stream << '	structure securityDecoration otherPermissions: '.
		self writePermissions: structure securityDecoration otherPermissions on: stream ]! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/29/2012 11:15'!
writePermissions: permissions on: stream
	stream << '(self permissionSetFrom: {'.
	permissions do: [ :each |
		stream << each command name ] separatedBy: [ stream nextPutAll: '. '].
	stream << '}).' << String cr.! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 1/28/2012 19:01'!
writeUser: user on: stream
	stream << '((PUUser named: ''' << user name << ''')' << String cr <<
		'			groups: (OrderedCollection new' << String cr. 
	user groups do: [ :each |
		stream << '				add: (kernel groupNamed: ''' << each name << ''' ifNone: nil);' << String cr ].
	stream << '				yourself);' << String cr.
	stream << '			instVarNamed: ''password'' put: ' << (user instVarNamed: 'password') << ';' << String cr.
	stream << '			email: '; print: user email; nextPut: $;; nextPut: Character cr.
	stream << '			firstName: '; print: user firstName; nextPut: $;; nextPut: Character cr.
	stream << '			lastName: '; print: user lastName; nextPut: $;; nextPut: Character cr.			
	user superuser ifTrue: [
		stream << '			superuser: true;' << String cr ].
	stream << '			yourself);' << String cr! !

GRObject subclass: #PRKernelCreatorBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRKernelCreatorBase class methodsFor: 'instance creation' stamp: 'NickAger 2/8/2012 17:35'!
register
	^ self new register! !

!PRKernelCreatorBase methodsFor: 'helpers' stamp: 'NickAger 2/11/2012 21:43'!
clearInternalLinkTargetsStartingAt: startingStructure
	"PRDocumentItem content is created before all the parents and children have
	been wired together, resulting in incorrectly realised internal links. Here we clear
	the links target which will be reinitialised when the link is first visited."
	startingStructure enumerator with; all; do: [ :each |
		each outgoingReferences do: [ :link |
			(link isKindOf: PRInternalLink) ifTrue: [ link target: nil ] ] ]! !

!PRKernelCreatorBase methodsFor: 'creation' stamp: 'NickAger 2/11/2012 21:43'!
createKernel
	| kernel |
	kernel := PRKernel named: self kernelName.
	self addGroupsToKernel: kernel.
	self addUsersToKernel: kernel.
	kernel root: (self root: kernel).
	self clearInternalLinkTargetsStartingAt: kernel root.
	^ kernel! !

!PRKernelCreatorBase methodsFor: 'helpers' stamp: 'NickAger 2/9/2012 14:39'!
permissionSetFrom: commands
	^ (commands collect: [ :each | PUPermission on: each ]) asSet! !

!PRKernelCreatorBase methodsFor: 'creation' stamp: 'NickAger 2/8/2012 17:43'!
register 
	^ PRPierFrame registerAsApplication: self dispatcherPathName kernel: self createKernel! !

!PRStructure methodsFor: '*pier-exporter-code' stamp: 'NickAger 1/28/2012 15:37'!
asSelector
	| aName selector |
	aName := self absolutePath.
	aName := (aName = '/') ifTrue: [ self name ] ifFalse: [ aName ].

	selector := aName select: [ :each | each isAlphaNumeric ].
	[ selector first isDigit ]
		whileTrue: [ selector := selector allButFirst ].
		
	selector at: 1 put: (selector at: 1) asLowercase.
		
	^ selector asSymbol! !

!PRStructure methodsFor: '*pier-exporter-code' stamp: 'NickAger 1/28/2012 19:06'!
codeOn: aStream
	aStream << '(self ' << self asSelector << ': kernel)'! !

!Collection methodsFor: '*pier-exporter-code' stamp: 'NickAger 2/6/2012 17:47'!
codeOn: aStream
	aStream << '#('.
	self do: [ :each | each codeOn: aStream ] separatedBy: [ aStream nextPutAll: ' '].
	aStream << ')'! !
